#ifndef RAWMICROBLOCKV1_H
#define RAWMICROBLOCKV1_H
#include "DAQDataFormats/RawMicroBlockV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlock
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawmicroblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace VERSION_NAMESPACE {

  /// MicroBlock header size + MicroSlice Header
  static const uint32_t MICROBLOCK_HEADER_STUFF = rawmicroblockhdr::RAWMICROBLOCKHEADER_SIZE + RAWMICROSLICEHEADER_SIZE;

  class RawMicroBlock : public PREVIOUS_VERSION_CLASS_NAME {
        public:
            // Constructors
            RawMicroBlock (const version_t); //! The default constructor
            RawMicroBlock (const RawMicroBlock&);
            /// Destructor
            ~RawMicroBlock();

            bool     setBufferSource(const void* pointer);

            using PREVIOUS_VERSION_CLASS_NAME::readData;	// unhide the reset of the readData methods
            void*                              readData(const void*);

  };


}}// END NAMESPCE daqdataformats
#endif /* RawMicroBlockV1V0_H */
