#ifndef DAQRAWTRIGGERV1_H
#define DAQRAWTRIGGERV1_H
#include "DAQDataFormats/RawTriggerV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTrigger
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawtrigger
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace  VERSION_NAMESPACE {


  //! Class to hold the data from the global trigger header in the correct format
  /*!
    The RawTriggerV1 contains the basic information required to
    reconstruct where and how the trigger was generated.

    The class supports general initialization with an internal or external
    data buffer as well as copyin style initialization for use with
    STL containers.
  */
  class RawTrigger : public PREVIOUS_VERSION_CLASS_NAME {

        public:
            // Constructors
            RawTrigger (const version_t); //! The default constructor
            RawTrigger (const RawTrigger&);
            /// Destructor
            ~RawTrigger();

  };
  
  
}} // END NAMESPCE daqdataformats
#endif /* DAQRAWTRIGGERV1_H */
