
set( novadaq_VERSION 04.07.00 )
set( novadaq_UPS_VERSION v04_07_00 )


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was product-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################


## find_ups_product directives
## remember that these are minimum required versions
    find_ups_product( postgresql v9_1_5b )
    find_ups_product( xerces_c v3_1_1b )
    find_ups_product( libwda v2_7_0 )
    find_ups_product( messagefacility v1_11_0 )
    find_ups_product( fhiclcpp v2_17_00 )
    find_ups_product( cetlib v1_09_00 )
    find_ups_product( cpp0x v1_03_02 )
    find_ups_boost( v1_50_0 )
    find_ups_product( sqlite v3_07_15_00 )


## find_library directives
    if( NOT SQLITE3 )
      cet_find_library( SQLITE3 NAMES sqlite3_ups PATHS ENV SQLITE_LIB NO_DEFAULT_PATH )
    endif()
      set( DATABASEUTILS  $ENV{NOVADAQ_LIB}/libDatabaseUtils.so )
      set( DATABASEUTILSDAQAPPMGR  $ENV{NOVADAQ_LIB}/libDatabaseUtilsDAQAppMgr.so )
      set( DATABASEUTILSDAQCONFIG  $ENV{NOVADAQ_LIB}/libDatabaseUtilsDAQConfig.so )
      set( DATABASEUTILSDCS  $ENV{NOVADAQ_LIB}/libDatabaseUtilsDCS.so )
      set( DATABASEUTILSRUNHISTORY  $ENV{NOVADAQ_LIB}/libDatabaseUtilsRunHistory.so )
      set( DAQCHANNELMAP  $ENV{NOVADAQ_LIB}/libDAQChannelMap.so )
      set( DAQDATAFORMATS  $ENV{NOVADAQ_LIB}/libDAQDataFormats.so )
      set( DAQQUALITYCHECK  $ENV{NOVADAQ_LIB}/libDAQQualityCheck.so )
      set( EVENTDISPATCHER_COMMANDSET  $ENV{NOVADAQ_LIB}/libEventDispatcher_CommandSet.so )
      set( NOVADATABASE  $ENV{NOVADAQ_LIB}/libNovaDatabase.so )
      set( NOVADAQUTILITIES  $ENV{NOVADAQ_LIB}/libNovaDAQUtilities.so )
      set( NOVATIMINGUTILITIES  $ENV{NOVADAQ_LIB}/libNovaTimingUtilities.so )
      set( PACKAGEVERSION  $ENV{NOVADAQ_LIB}/libPackageVersion.so )
      set( RAWFILEPARSER  $ENV{NOVADAQ_LIB}/libRawFileParser.so )
      set( SHMRDWR  $ENV{NOVADAQ_LIB}/libShmRdWr.so )
      set( SHMMILLIBLOCK  $ENV{NOVADAQ_LIB}/libShmMilliBlock.so )
      include_directories ( $ENV{NOVADAQ_INC} )

check_required_components(novadaq)
