#include "DAQDataFormats/RawTrigger.h"
#include "DAQDataFormats/DataFormatException.h"
/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTrigger
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE rawtrigger
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{

//------------------------Constructors------------------------------------------
/// After this constructor the buffer pointer is set to the internal source
RawTrigger::RawTrigger(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" start")
    reserveInternalBuffer(CURRENT_FIELDS_SUB_NAMESPACE::RAWTRIGGER_MAXIMUM_SIZE);

    /// Perform general routines
    defaultConstructorFixedSize();
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" end")
}// end of :RawTrigger(version_t version)


RawTrigger::RawTrigger(const RawTrigger& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" start")
    lastOperationsInDeepCopy(copy_in);
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" end")
}

//------------------------------------------------------------------------------
// check how to get the version number
RawTrigger::RawTrigger(const void* nanoslice_buffer, const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" start")
    copy(nanoslice_buffer);
    PRINT_ON_DEBUG(__PRETTY_FUNCTION__<<" end")
}

//------------------------Destructor--------------------------------------------
RawTrigger::~RawTrigger() { }

/// All binding routines
#define STANDARD_ROUTINES                           \
            BIND_SET(TriggerHeader       , version0, daqdataformats::RawTriggerHeader&);\
            BIND_SET(TriggerTimingMarker , version0, daqdataformats::RawTriggerTimingMarker&);\
            BIND_SET(TriggerRange        , version0, daqdataformats::RawTriggerRange&);\
            BIND_SET(TriggerTime         , version0, daqdataformats::RawTriggerTime&);\
            BIND_SET(TriggerMask         , version0, daqdataformats::RawTriggerMask&);\
            BIND_GET_AND_SET(TriggerStart, version0, uint64_t);\
            BIND_STADARD_FUNCTION(sizeofdata); \
            BIND_STADARD_FUNCTION(setBufferSource); \
            CURRENT_VERSION_NAMESPACE::CURRENT_CLASS::setVersions();\
            BIND_CUSTOM_FUNCTION(readDataFromFileDescriptor, version0,,readDataStatus, const int); 
            

#include "DAQDataFormats/setFunctionPointers_template.inc"



} //end of namespace
